'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _stcPlugin = require('stc-plugin');

var _stcPlugin2 = _interopRequireDefault(_stcPlugin);

var _stcHelper = require('stc-helper');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _url = require('url');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RegInCss = [_stcHelper.ResourceRegExp.background, _stcHelper.ResourceRegExp.font, _stcHelper.ResourceRegExp.filter];

var RegLsCookie = /lscookie\s*=\s*[\'\"]?(\w+)[\'\"]?/i;

//默认配置项
var DefaultOpt = {
  minLength: 1000, //存到 LS 中的文件允许的最小字符数

  nlsCookie: 'stc_nls', //不支持 LS 时，记录的 cookie name
  lsCookie: 'stc_ls',

  htmlToLs: 'LS.html2ls', //基础 JS 提供的三个接口
  lsToHtml: 'LS.ls2html',
  updateVersion: 'LS.updateVersion',

  blockStart: '', //指定定界符。不指定时取 config.tpl.ld/rd
  blockEnd: '',
  variableStart: '',
  variableEnd: ''
};

var LsConfigKey = '--stc-ls-config-key--';

var KeyList = 'RzS!T(U_V~W0X2Y4Z6a8bAcCdEeGfIgKhMiOjQk)l-m3n7oBpFqJrNs*t1u9HyxwvLD5.P'.split('');

//localstorage 基础 JS 的路径
var LsJsPath = __dirname + '/../misc';

//localstorage 基础 JS 代码
var LsJsCode = '';

//Adapter 实例
var Adapter = null;

//APP Config 的路径
var AppConfigPath = __dirname + '/../tmp';

//APP 的 LS 配置
var AppConfig = null;

//已经处理过的 data-ls 属性
var LsNames = {};

var LocalstoragePlugin = function (_Plugin) {
  (0, _inherits3.default)(LocalstoragePlugin, _Plugin);

  function LocalstoragePlugin() {
    (0, _classCallCheck3.default)(this, LocalstoragePlugin);
    return (0, _possibleConstructorReturn3.default)(this, _Plugin.apply(this, arguments));
  }

  /**
   * run
   */

  LocalstoragePlugin.prototype.run = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var content, appId, adapter, oldTokens, newTokens, findLSFlag, _iterator, _isArray, _i, _ref, token, tokenType, tokens, attrs, _tokens;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.getContent('utf-8');

            case 2:
              content = _context.sent;

              if (!(!RegLsCookie.test(content) || content.indexOf('data-ls') < 0)) {
                _context.next = 5;
                break;
              }

              return _context.abrupt('return');

            case 5:

              //mix 默认配置
              this.options = (0, _stcHelper.extend)(DefaultOpt, this.options);

              //APP ID 校验
              appId = this.options.appId;

              if (appId) {
                _context.next = 10;
                break;
              }

              this.fatal('options.appId must be set');
              return _context.abrupt('return');

            case 10:
              if (AppConfig) {
                _context.next = 20;
                break;
              }

              //读取 APP Config
              this.getAppConfig();

              //Adapter
              adapter = this.options.adapter;


              if (adapter && typeof adapter.default === 'function') {
                adapter = adapter.default;
              }

              if (!(typeof adapter !== 'function')) {
                _context.next = 17;
                break;
              }

              this.fatal('options.adapter must be a function');
              return _context.abrupt('return');

            case 17:

              Adapter = new adapter(this.options, this.config);

              //localstorage 基础 JS 代码
              LsJsCode = _fs2.default.readFileSync(LsJsPath + '/localstorage.js', 'utf8');
              LsJsCode = this.avoidHasDelimiters(LsJsCode);

            case 20:
              _context.next = 22;
              return this.getAst();

            case 22:
              oldTokens = _context.sent;
              newTokens = [];
              findLSFlag = false;
              _iterator = oldTokens, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);

            case 26:
              if (!_isArray) {
                _context.next = 32;
                break;
              }

              if (!(_i >= _iterator.length)) {
                _context.next = 29;
                break;
              }

              return _context.abrupt('break', 59);

            case 29:
              _ref = _iterator[_i++];
              _context.next = 36;
              break;

            case 32:
              _i = _iterator.next();

              if (!_i.done) {
                _context.next = 35;
                break;
              }

              return _context.abrupt('break', 59);

            case 35:
              _ref = _i.value;

            case 36:
              token = _ref;
              tokenType = token.type;

              //找到了 LS 占位符

              if (!(tokenType === this.TokenType.TPL && RegLsCookie.test(token.ext.value))) {
                _context.next = 45;
                break;
              }

              findLSFlag = true;

              _context.next = 42;
              return this.getlsFlagTokens();

            case 42:
              tokens = _context.sent;

              [].push.apply(newTokens, tokens);

              return _context.abrupt('continue', 57);

            case 45:
              if (!(tokenType === this.TokenType.HTML_TAG_SCRIPT || tokenType === this.TokenType.HTML_TAG_START && token.ext.tag === 'link')) {
                _context.next = 56;
                break;
              }

              attrs = this.getAttrs(tokenType, token);

              //在外链标签上找到了 data-ls 标记

              if (!this.hasLsAttr(tokenType, attrs)) {
                _context.next = 56;
                break;
              }

              if (findLSFlag) {
                _context.next = 51;
                break;
              }

              this.fatal('localStorage cookie name must be set before style or script', token.loc.start.line, token.loc.start.column);
              return _context.abrupt('return', []);

            case 51:
              _context.next = 53;
              return this.getLsTagTokens(tokenType, token, attrs);

            case 53:
              _tokens = _context.sent;

              [].push.apply(newTokens, _tokens);

              return _context.abrupt('continue', 57);

            case 56:

              //其它情况
              newTokens.push(token);

            case 57:
              _context.next = 26;
              break;

            case 59:
              return _context.abrupt('return', newTokens);

            case 60:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function run() {
      return ref.apply(this, arguments);
    }

    return run;
  }();
  /**
   * avoid has delimiters
   */


  LocalstoragePlugin.prototype.avoidHasDelimiters = function avoidHasDelimiters(content) {
    var delimiters = [].concat(this.config.tpl.ld).concat(this.config.tpl.rd);

    var _loop = function _loop() {
      var rcontent = content;
      delimiters.forEach(function (item) {
        if (item.length <= 1) {
          return;
        }
        rcontent = rcontent.replace(item, item[0] + ' ' + item.slice(1));
      });
      if (rcontent === content) {
        return 'break';
      }
      content = rcontent;
    };

    while (true) {
      var _ret = _loop();

      if (_ret === 'break') break;
    }
    return content;
  };

  //根据含有 data-ls 属性的 token 生成新的 token lists


  LocalstoragePlugin.prototype.getLsTagTokens = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(tokenType, token, attrs) {
      var isScript, lsName, source, file, content, stcLsName, newTokens, i, sourceFile, sourceContent, tokens, sourceToken, sourceMd5, supportCode, conditionCode;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              isScript = tokenType === this.TokenType.HTML_TAG_SCRIPT;
              lsName = this.stc.flkit.getHtmlAttrValue(attrs, 'data-ls');

              //data-ls 值的合法性校验

              if (/^\w+$/.test(lsName)) {
                _context2.next = 5;
                break;
              }

              this.fatal('data-ls="' + lsName + '" is not valid', token.loc.start.line, token.loc.start.column);
              return _context2.abrupt('return', []);

            case 5:
              source = this.stc.flkit.getHtmlAttrValue(attrs, isScript ? 'src' : 'href');

              //远程地址移除 data-ls 后原样输出

              if (!(0, _stcHelper.isRemoteUrl)(source)) {
                _context2.next = 9;
                break;
              }

              this.removeLsAttr(tokenType, token);
              return _context2.abrupt('return', [token]);

            case 9:
              file = void 0;
              _context2.prev = 10;

              file = this.getFileByPath(source);
              _context2.next = 18;
              break;

            case 14:
              _context2.prev = 14;
              _context2.t0 = _context2['catch'](10);

              this.fatal('can\'t open \'' + source + '\' file', token.loc.start.line, token.loc.start.column);
              return _context2.abrupt('return', []);

            case 18:
              _context2.next = 20;
              return file.getContent('utf-8');

            case 20:
              content = _context2.sent;

              if (!(content.length < this.options.minLength)) {
                _context2.next = 24;
                break;
              }

              this.fatal('data-ls="' + lsName + '" content length less than ' + this.options.minLength + ' in file', token.loc.start.line, token.loc.start.column);
              return _context2.abrupt('return', []);

            case 24:
              if (LsNames[lsName]) {
                _context2.next = 28;
                break;
              }

              LsNames[lsName] = [];
              _context2.next = 31;
              break;

            case 28:
              if (!(LsNames[lsName].indexOf(source) === -1)) {
                _context2.next = 31;
                break;
              }

              //如果不是之前出现的值，就报错
              this.fatal('data-ls="' + lsName + '" is conflict, ' + source + ', ' + LsNames[lsName].join(','), token.loc.start.line, token.loc.start.column);
              return _context2.abrupt('return', []);

            case 31:
              LsNames[lsName].push(source);

              stcLsName = 'stc_' + lsName;
              newTokens = [];
              i = 0;
              sourceFile = this.getFileByPath(source);
              sourceContent = void 0;

              if (!isScript) {
                _context2.next = 43;
                break;
              }

              _context2.next = 40;
              return sourceFile.getContent('utf-8');

            case 40:
              sourceContent = _context2.sent;
              _context2.next = 53;
              break;

            case 43:
              _context2.next = 45;
              return sourceFile.getAst();

            case 45:
              tokens = _context2.sent;


              //resolve relative path
              tokens = this.resolvePathInCss(source, tokens);

              //tokens => content
              _context2.next = 49;
              return sourceFile.setAst(tokens);

            case 49:
              _context2.next = 51;
              return sourceFile.getContent('utf-8');

            case 51:
              sourceContent = _context2.sent;

              sourceContent = this.avoidHasDelimiters(sourceContent);

            case 53:

              //创建对应资源 inline 形态的 token
              sourceToken = this.createRawToken(this.TokenType[isScript ? 'HTML_TAG_SCRIPT' : 'HTML_TAG_STYLE'], sourceContent);

              sourceToken.ext.start.ext.attrs = [{ name: 'id', value: stcLsName, quote: '"', nameLowerCase: 'id' }];

              sourceMd5 = (0, _stcHelper.md5)(sourceContent);

              //如果文件有改动，更新版本号

              this.updateLsConfigVersion(lsName, sourceMd5);

              supportCode = Adapter.getLsSupportCode();
              conditionCode = Adapter.getLsConditionCode(lsName);


              newTokens[i++] = this.createToken(this.TokenType.TPL, supportCode.if);
              newTokens[i++] = this.createToken(this.TokenType.TPL, conditionCode.if);
              newTokens[i++] = this.createRawToken(this.TokenType.HTML_TAG_SCRIPT, this.options.lsToHtml + '("' + stcLsName + '","' + (isScript ? 'script' : 'style') + '","' + this.options.lsCookie + '")');
              newTokens[i++] = this.createToken(this.TokenType.TPL, conditionCode.else);
              newTokens[i++] = sourceToken;
              newTokens[i++] = this.createRawToken(this.TokenType.HTML_TAG_SCRIPT, this.options.htmlToLs + '("' + stcLsName + '","' + stcLsName + '");' + this.options.updateVersion + '("' + this.options.lsCookie + '", "' + conditionCode.key + '", "' + conditionCode.version + '");');
              newTokens[i++] = this.createToken(this.TokenType.TPL, conditionCode.end);
              newTokens[i++] = this.createToken(this.TokenType.TPL, supportCode.else);
              //不支持 LocalStorage，移除 data-ls 后原样输出
              this.removeLsAttr(tokenType, token);
              newTokens[i++] = token;
              newTokens[i++] = this.createToken(this.TokenType.TPL, supportCode.end);

              return _context2.abrupt('return', newTokens);

            case 71:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this, [[10, 14]]);
    }));

    function getLsTagTokens(_x, _x2, _x3) {
      return ref.apply(this, arguments);
    }

    return getLsTagTokens;
  }();

  //处理 css 中引用资源的路径


  LocalstoragePlugin.prototype.resolvePathInCss = function resolvePathInCss(cssPath, tokens) {
    var _this2 = this;

    var newTokens = [];

    tokens.forEach(function (token) {
      // css value
      if (token.type === _this2.TokenType.CSS_VALUE) {
        RegInCss.some(function (item) {
          var flag = false;

          token.ext.value.replace(item, function () {
            var resPath = arguments.length <= 2 ? undefined : arguments[2];

            // only resolve relative path
            if (resPath && !(0, _stcHelper.isRemoteUrl)(resPath) && /^\.{2}\//.test(resPath)) {
              flag = true;

              var resolvedResPath = (0, _url.resolve)(cssPath, resPath);

              token = (0, _stcHelper.extend)({}, token);
              token.value = token.value.replace(resPath, resolvedResPath);
              token.ext.value = token.value;
            }

            return flag;
          });
        });
      }

      newTokens.push(token);
    });

    return newTokens;
  };

  //生成替换占位符对应代码的 token


  LocalstoragePlugin.prototype.getlsFlagTokens = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var newTokens, i, supportCode, baseCode, parseCookieCode;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              newTokens = [];
              i = 0;
              supportCode = Adapter.getLsSupportCode();
              baseCode = Adapter.getLsBaseCode();
              parseCookieCode = Adapter.getLsParseCookieCode();


              newTokens[i++] = this.createRawToken(this.TokenType.TPL, supportCode.if);
              newTokens[i++] = this.createRawToken(this.TokenType.TPL, baseCode.if);
              newTokens[i++] = this.createRawToken(this.TokenType.HTML_TAG_SCRIPT, LsJsCode);
              newTokens[i++] = this.createRawToken(this.TokenType.TPL, baseCode.end);
              newTokens[i++] = this.createRawToken(this.TokenType.TPL, parseCookieCode);
              newTokens[i++] = this.createRawToken(this.TokenType.TPL, LsConfigKey);
              newTokens[i++] = this.createRawToken(this.TokenType.TPL, supportCode.end);

              return _context3.abrupt('return', newTokens);

            case 13:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function getlsFlagTokens() {
      return ref.apply(this, arguments);
    }

    return getlsFlagTokens;
  }();

  //获取一个 token 的所有 attr


  LocalstoragePlugin.prototype.getAttrs = function getAttrs(tokenType, token) {
    var attrs = [];

    //处理 Link
    if (tokenType === this.TokenType.HTML_TAG_START) {
      attrs = token.ext.attrs;

      return attrs;
    }

    //处理 Script
    if (tokenType === this.TokenType.HTML_TAG_SCRIPT) {
      attrs = token.ext.start.ext.attrs;

      return attrs;
    }

    return [];
  };

  LocalstoragePlugin.prototype.removeLsAttr = function removeLsAttr(tokenType, token) {
    if (tokenType === this.TokenType.HTML_TAG_START) {
      token.ext.attrs = token.ext.attrs.filter(function (attr) {
        return attr.name !== 'data-ls';
      });
    } else {
      token.ext.start.ext.attrs = token.ext.start.ext.attrs.filter(function (attr) {
        return attr.name !== 'data-ls';
      });
    }
  };

  //判断 attr 中是否存在 data-ls


  LocalstoragePlugin.prototype.hasLsAttr = function hasLsAttr(tokenType, attrs) {
    //处理 Link
    if (tokenType === this.TokenType.HTML_TAG_START) {
      //不是 CSS，直接返回
      if (this.stc.flkit.getHtmlAttrValue(attrs, 'rel') !== 'stylesheet') {
        return false;
      }

      //没有 data-ls 属性，直接返回
      if (!this.stc.flkit.getHtmlAttrValue(attrs, 'data-ls')) {
        return false;
      }

      //没有 href 属性，直接返回
      if (!this.stc.flkit.getHtmlAttrValue(attrs, 'href')) {
        return false;
      }

      return true;
    }
    //处理 Script
    else if (tokenType === this.TokenType.HTML_TAG_SCRIPT) {
        //没有 data-ls 属性，直接返回
        if (!this.stc.flkit.getHtmlAttrValue(attrs, 'data-ls')) {
          return false;
        }

        //没有 src 属性，直接返回
        if (!this.stc.flkit.getHtmlAttrValue(attrs, 'src')) {
          return false;
        }

        return true;
      }

    return false;
  };

  LocalstoragePlugin.prototype.updateLsConfigVersion = function updateLsConfigVersion(lsName, sourceMd5) {
    var lsConfig = this.getLsConfig(lsName);

    if (!lsConfig.md5) {
      lsConfig.md5 = sourceMd5;
      return;
    }

    if (lsConfig.md5 !== sourceMd5) {
      lsConfig.md5 = sourceMd5;

      var version = lsConfig.version;
      var index = KeyList.indexOf(version);

      if (index >= KeyList.length - 1) {
        index = 0;
      } else {
        index++;
      }

      var newVersion = KeyList[index];
      lsConfig.version = newVersion;
    }
  };

  LocalstoragePlugin.prototype.getLsConfig = function getLsConfig(lsName) {
    var lsConfig = AppConfig[lsName];

    if (lsConfig) {
      lsConfig.invoked = true;

      return lsConfig;
    }

    var keyIndex = -1;
    for (var _ in AppConfig) {
      var config = AppConfig[_];
      var key = config.key;
      var index = KeyList.indexOf(key);

      keyIndex = Math.max(keyIndex, index);
    }

    var fileKey = ''; //新文件的 Key

    if (keyIndex === -1) {
      fileKey = KeyList[0]; //从 0 开始
    } else {
      if (keyIndex < KeyList.length - 1) {
        //文件还没满，则使用下一个
        fileKey = KeyList[keyIndex + 1];
      } else {
        //文件已满，则找出之前使用但现在已经不使用的 key，如果没有则报错，文件个数不能大于 64 个
        KeyList.forEach(function (key) {
          var flag = false;

          for (var _2 in AppConfig) {
            var _config = AppConfig[_2];

            //表示这个 key 被用过
            if (_config.key === key) {
              flag = true;
              break;
            }
          }

          if (!flag) {
            fileKey = key;
            return;
          }
        });
      }
    }

    if (!fileKey) {
      this.fatal('data-ls nums can not max than 70');
      return {};
    }

    var data = {
      key: fileKey,
      version: KeyList[0],
      md5: '',
      invoked: true
    };

    AppConfig[lsName] = data;

    return data;
  };

  LocalstoragePlugin.prototype.getAppConfig = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var appConfigFile;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (!(0, _stcHelper.isDirectory)(AppConfigPath)) {
                (0, _stcHelper.mkdir)(AppConfigPath);
              }

              appConfigFile = AppConfigPath + '/' + this.options.appId + '.json';


              if ((0, _stcHelper.isFile)(appConfigFile)) {
                try {
                  AppConfig = JSON.parse(_fs2.default.readFileSync(appConfigFile, 'utf8'));
                } catch (e) {
                  AppConfig = {};
                }
              } else {
                AppConfig = {};
              }

            case 3:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function getAppConfig() {
      return ref.apply(this, arguments);
    }

    return getAppConfig;
  }();

  LocalstoragePlugin.prototype.readFile = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(path) {
      var readFile;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              readFile = (0, _stcHelper.promisify)(_fs2.default.readFile, _fs2.default);
              _context5.next = 3;
              return readFile(path);

            case 3:
              return _context5.abrupt('return', _context5.sent.toString('utf-8'));

            case 4:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function readFile(_x4) {
      return ref.apply(this, arguments);
    }

    return readFile;
  }();

  LocalstoragePlugin.prototype.update = function update(tokens) {
    if (tokens) {
      this.setAst(tokens);
    }
  };

  //全部文件跑完之后的全局处理


  LocalstoragePlugin.after = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(files, instance) {
      var _this3 = this;

      var simpleConfig, newConfig, lsName, config, configCode, writeFile, appConfigFile;
      return _regenerator2.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (AppConfig) {
                _context7.next = 2;
                break;
              }

              return _context7.abrupt('return');

            case 2:
              simpleConfig = {};
              newConfig = {};


              for (lsName in AppConfig) {
                config = AppConfig[lsName];


                if (config.invoked) {
                  delete config.invoked;
                  newConfig[lsName] = (0, _stcHelper.extend)({}, config);

                  delete config.md5;
                  simpleConfig[lsName] = config;
                }
              }

              configCode = Adapter.getLsConfigCode(simpleConfig);

              //替换占位符

              files.forEach(function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(file) {
                  var fileContent;
                  return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          _context6.next = 2;
                          return file.getContent('utf-8');

                        case 2:
                          fileContent = _context6.sent;

                          fileContent = fileContent.replace(new RegExp(LsConfigKey, 'g'), configCode);
                          _context6.next = 6;
                          return file.setContent(fileContent);

                        case 6:
                        case 'end':
                          return _context6.stop();
                      }
                    }
                  }, _callee6, _this3);
                }));
                return function (_x7) {
                  return ref.apply(this, arguments);
                };
              }());

              //存储文件
              writeFile = (0, _stcHelper.promisify)(_fs2.default.writeFile, _fs2.default);
              appConfigFile = AppConfigPath + '/' + instance.options.appId + '.json';
              _context7.next = 11;
              return writeFile(appConfigFile, (0, _stringify2.default)(newConfig));

            case 11:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function after(_x5, _x6) {
      return ref.apply(this, arguments);
    }

    return after;
  }();
  /**
   * default include
   */


  LocalstoragePlugin.include = function include() {
    return { type: 'tpl' };
  };

  LocalstoragePlugin.cluster = function cluster() {
    return false;
  };

  LocalstoragePlugin.cache = function cache() {
    return false;
  };

  return LocalstoragePlugin;
}(_stcPlugin2.default);

exports.default = LocalstoragePlugin;
//# sourceMappingURL=index.js.map